#include "trackerworker.h"
#include <QThread>
#include "frontend_common.h"
#include "frontend_tracker.h"

TrackerWorker::TrackerWorker() :
    QObject(), conn(NULL)
{
}

TrackerWorker::~TrackerWorker()
{
    disconnectBackend();
}

void TrackerWorker::connectBackend()
{
    conn = ucart_backendConnect();
}

void TrackerWorker::disconnectBackend()
{
    if (conn) {
         ucart_backendDisconnect(conn);
         conn = NULL;
    }
}

void TrackerWorker::process()
{
    if (conn) {
        struct frontend_tracker_data td;
        frontend_track(conn, &td);

        emit finished(td.height, td.lateral, td.longitudinal, td.pitch, td.roll, td.yaw);
    }
}
